# サブスクリプション 解約

`DELETE /v1/subscriptions/{id}`

- operationId: `unsubscripbeSubscription`
- tags: サブスクリプション

IDで指定したサブスクリプションを解約し、請求を停止します。


## コードサンプル

### cURL

```bash
curl \
    -X DELETE \
    -H "Authorization:Bearer <Secret API Key>" \
'https://api.test.fincode.jp/v1/subscriptions/{id}?pay_type=Card'
```

### Node.js

```javascript
import { createFincode } from "@fincode/node";

const API_KEY = "<Secret API Key>";

(async () => {
    const fincode = createFincode({ apiKey: API_KEY, isLiveMode: false });

    const subscriptionId = "<Subscription ID>";

    try {
        // リクエストの送信
        const subscription = await fincode.subscriptions.cancel(
            subscriptionId,
            {
                pay_type: "Card",
            }
        );
    } catch (e) {
        // エラーの処理
    }
})();
```

### Go

```go
package main

import (
	"fmt"
	"log"
	"net/http"
)

func main() {

	apiKey := "<Secret API Key>"

	subscriptionID := "<Subscription ID>"

	// リクエストの作成
	req, _ := http.NewRequest(
		"DELETE",
		fmt.Sprintf("https://api.test.fincode.jp/v1/subscriptions/%s", subscriptionID),
		nil,
	)
	req.Header.Set("Authorization", fmt.Sprintf("Bearer %s", apiKey))

	params := req.URL.Query()
	params.Add("pay_type", "Card")
	req.URL.RawQuery = params.Encode()

	// リクエストの送信
	client := &http.Client{}
	res, err := client.Do(req)
	if err != nil {
		log.Fatal(err)
	}
	defer res.Body.Close()
}
```

### PHP

```php
<?php

$apiKey = '<Secret API Key>';

$subscriptionId = '<Subscription ID>';

$baseUrl = "https://api.test.fincode.jp";
$endpoint = "/v1/subscriptions/{$subscriptionId}";
$queryParams = [
    "pay_type" => "Card",
];

$headers = [
    "Authorization: Bearer " . $apiKey,
];

$session = curl_init();
curl_setopt($session, CURLOPT_URL, $baseUrl . $endpoint . '?' . http_build_query($queryParams));
curl_setopt($session, CURLOPT_HTTPHEADER, $headers);
curl_setopt($session, CURLOPT_CUSTOMREQUEST, 'DELETE');
curl_setopt($session, CURLOPT_RETURNTRANSFER, true);
// curl_setopt($session, CURLOPT_SSL_VERIFYPEER, );
// curl_setopt($session, CURLOPT_SSL_VERIFYHOST, );

$response = curl_exec($session);

if ($response === false) {
    # エラー処理
    echo "cURL Error: " . curl_error($session);
} else {
    # APIからのデータを処理
    var_dump($response);
}

curl_close($session);
```

### Python 3

```python
import requests

api_key = '<Secret API Key>'

subscription_id = '<Subscription ID>'

url = f'https://api.test.fincode.jp/v1/subscriptions/{subscription_id}'

# ヘッダーを設定
headers = {
    'Authorization': f'Bearer {api_key}',
}

try:
    response = requests.delete(url, headers=headers)

    # レスポンスの処理
    if response.status_code == 200:
        # APIからのデータを処理
        print(f"Success: {response.json()}")
    else:
        # エラーの処理
        print(f"Error: {response.json()}")
except requests.RequestException as e:
    # 通信エラーの処理
    print(f"Request error: {e}")
```

### Ruby

```ruby
require 'net/http'
require 'uri'

API_KEY = '<Secret API Key>'
BASE_URL = 'https://api.test.fincode.jp'

def main
    subscription_id = '<Subscription ID>'
    endpoint = "/v1/subscriptions/#{subscription_id}"
    query_params =  { pay_type: 'Card' }

    uri = URI.parse(BASE_URL + endpoint)
    uri.query = URI.encode_www_form(query_params)

    http = Net::HTTP.new(uri.host, uri.port)
    http.use_ssl = true

    # リクエストの作成
    request = Net::HTTP::Delete.new(uri.request_uri)
    request['Authorization'] = "Bearer #{API_KEY}"

    # リクエストの送信
    response = http.request(request)

    case response
    when Net::HTTPSuccess
        puts 'SUCCESS'
    else
        puts 'ERROR'
    end

    # レスポンスの表示
    puts response.body
end

main
```

## パラメータ

| 名前 | 位置 | 必須 | 型 | 説明 |
| --- | --- | --- | --- | --- |
| `id` | path | ✓ | SubscriptionId_schema | サブスクリプションID |

## レスポンス

### 200 リクエストに成功

| パラメータ | 型 | 必須 | 説明 |
| --- | --- | --- | --- |
| `id` | string |  | サブスクリプションID |
| `shop_id` | Shop_properties-id |  |  |
| `pay_type` | SubscriptionPayType |  |  |
| `plan_id` | Plan_properties-id |  |  |
| `plan_name` | plan_name |  |  |
| `customer_id` | id |  | 顧客ID |
| `card_id` | properties-id |  | カードID |
| `payment_method_id` | PaymentMethod_properties-id |  | 決済手段ID |
| `amount` | properties-amount |  |  |
| `tax` | properties-tax |  |  |
| `total_amount` | total_amount |  |  |
| `initial_amount` | integer |  | 初回利用金額 |
| `initial_tax` | integer |  | 初回税送料 |
| `initial_total_amount` | integer |  | 初回合計金額 |
| `status` | SubscriptionStatus |  |  |
| `start_date` | string |  | 課金開始日 |
| `next_charge_date` | string |  | 次回課金日 |
| `stop_date` | string |  | 課金停止日 |
| `end_month_flag` | enum(0 | 1) |  | 月末課金フラグ |
| `send_url` | string |  | ※ 閉塞機能 |
| `subscription_retry_mode` | enum(enabled | disabled) |  | リトライ対象設定 |
| `is_retry_scheduled` | boolean |  | リトライ予定フラグ |
| `error_code` | error_code |  | このサブスクリプションにおいて発生したエラーのうち、一番最新のエラーのエラーコードです。 |
| `client_field_1` | client_field_n |  | 加盟店自由項目 1 |
| `client_field_2` | client_field_n |  | 加盟店自由項目 2 |
| `client_field_3` | client_field_n |  | 加盟店自由項目 3 |
| `remarks` | remarks |  | ご利用明細表示内容 |
| `settlement_route` | DirectDebitSettlementRoute |  | 振替サービス |
| `created` | created |  |  |
| `updated` | updated |  |  |

### 400 不正なリクエスト

| パラメータ | 型 | 必須 | 説明 |
| --- | --- | --- | --- |
| `errors` | array<FincodeAPIError> |  |  |

